
package com.limegroup.gnutella.bootstrap;

import java.text.ParseException;

/**
 * The list of default GWebCache urls, used the first time LimeWire starts, or
 * if the gnutella.net file is accidentally deleted.  Entries in the list will
 * eventually be replaced by URLs discovered during urlfile=1 requests.  Order
 * does not matter.
 *
 * THIS FILE IS AUTOMATICALLY GENERATED FROM MAKE_DEFAULT.PY.
 */
public class DefaultBootstrapServers {
    /**
     * Adds all the default servers to bman. 
     */
    public static void addDefaults(BootstrapServerManager bman) {
        for (int i=0; i<urls.length; i++) {
            try {
                BootstrapServer server=new BootstrapServer(urls[i]);
                bman.addBootstrapServer(server);
            } catch (ParseException ignore) {
            }                
        }
    }

    //These should NOT be URL encoded.
    static String[] urls=new String[] {
        "http://80.81.50.205/skulls/skulls.php",
        "http://aniraws.com/bootstrap/skulls.php",
        "http://bbs.robertwoolley.co.uk/gwebcache/gcache.php",
        "http://beacon.awardspace.com/gwc.php",
        "http://drei.gtkg.net:8080/gwc/",
        "http://ein.gtkg.net:8080/gwc/",
        "http://filez.commorragh.org/gwc/",
        "http://gnutelladev1.udp-host-cache.com:8080/gwc/",
        "http://gnutelladev2.udp-host-cache.com:8080/gwc/",
        "http://gofoxy.net/gwc/cgi-bin/fc",
        "http://grantgalitz.com/Beacon/gwc.php",
        "http://gwc.ak-electron.eu:12050/",
        "http://gwc.chickenkiller.com:8080/gwc/",
        "http://gwc.cluephone.com/skulls.php",
        "http://gwc.dietpac.com:8080/",
        "http://gwc.eod.cc/skulls.php",
        "http://gwc.frodoslair.net.nyud.net/skulls/skulls.php",
        "http://gwc.frodoslair.net/skulls/skulls.php",
        "http://gwc.glucolene.com:8080/",
        "http://gwc.gofoxy.net:2108/gwc/cgi-bin/fc",
        "http://gwc.iblinx.com:2108/gwc/cgi-bin/fc",
        "http://gwc.lame.net/gwcii.php",
        "http://gwc.movingpages.org/gcache/xgcache.php",
        "http://gwc.movingpages.org/skulls.php",
        "http://gwc.nickstallman.net/",
        "http://gwc.pantheraproject.net/gwc.php",
        "http://gwc.stalin.lv/skulls/skulls.php",
        "http://gwc1.nickstallman.net/",
        "http://gwc2.nickstallman.net/",
        "http://gweb.4octets.co.uk/skulls.php",
        "http://gweb2.4octets.co.uk/gwc.php",
        "http://gwebcache.spearforensics.com/skulls.php",
        "http://leet.gtkg.org:8080/gwc/",
        "http://secondary.udp-host-cache.com:8080/gwc/",
        "http://silvers.servehttp.com/Beacon/gwc.php",
        "http://sissy.gtkg.org:8080/gwc/",
        "http://tabletka.tc.lv/skulls/skulls.php",
        "http://tertiary.udp-host-cache.com:8080/gwc/",
        "http://wc.neoboffins.com/index.php",
        "http://zwei.gtkg.net:8080/gwc/"
    };
}
